package com.xyhy.xingshenmqttcluster.common.domain;

import lombok.Data;

import java.io.Serializable;
import java.util.Date;

@Data
public class IvCar implements Serializable {

    private static final long serialVersionUID = -7298597230336141186L;

    /**
     * id
     */
    private Integer id;

    /**
     * 车云平台车辆ID
     */
    private String ivCarId;

    /**
     * 车云平台运力资源ID
     */
    private String ivCapacityResourceId;

    /**
     * 车辆名称
     */
    private String carName;

    /**
     * 车辆型号
     */
    private String model;

    /**
     * 出厂编码
     */
    private String factoryCode;

    /**
     * 生产日期
     */
    private Date productDate;

    /**
     * 最高车速
     */
    private String maxSpeed;

    /**
     * 最大载重
     */
    private String maxPayload;

    /**
     * 当前所在经度
     */
    private String longitude;

    /**
     * 当前所在纬度
     */
    private String latitude;

    /**
     * 当前海拔
     */
    private String altitude;

    /**
     * 当前驾驶角度
     */
    private String steerAngle;

    /**
     * 当前所在位置方向角
     */
    private String azimuth;

    /**
     * 当前楼层
     */
    private Integer regionId;

    /**
     * 当前速度
     */
    private String speed;

    /**
     * 当前驾驶模式
     */
    private String driveMode;

    /**
     * 剩余电量
     */
    private String residualFuel;

    /**
     * 当前电压
     */
    private String voltage;

    /**
     * 当前电流
     */
    private String ammeter;

    /**
     * 当前温度
     */
    private String temperature;

    /**
     * 耐力
     */
    private String endurance;

    /**
     * 总里程
     */
    private String odometer;

    /**
     * 删除标志（0正常；1删除）
     */
    private String delFlag;

    /**
     * 车辆在线状态（0离线；1在线；2未知）
     */
    private Integer status;

    /**
     * 车辆是否充电中（0否；1是；2未知）
     */
    private Integer chargeStatus;

    /**
     * 车辆是否锁定（0否；1是）
     */
    private Integer lockStatus;

    /**
     * 车辆补电插口状态（0未知；1空闲；2已插枪；3充电中）
     */
    private Integer pluginStatus;

    /**
     * 车辆在线状态
     */
    public enum Status {
        offline(0, "离线"),
        online(1, "在线"),
        unknown(2, "未知");

        private int code;
        private String message;

        private Status(int code, String message) {
            this.code = code;
            this.message = message;
        }

        public int getCode() {
            return code;
        }

        public String getMessage() {
            return message;
        }
    }

    /**
     * 车辆充电状态
     */
    public enum ChargeStatus {
        no(0, "否"),
        yes(1, "是"),
        unknown(2, "未知");

        private int code;
        private String message;

        private ChargeStatus(int code, String message) {
            this.code = code;
            this.message = message;
        }

        public int getCode() {
            return code;
        }

        public String getMessage() {
            return message;
        }
    }

    /**
     * 车辆锁定状态
     */
    public enum LockStatus {
        no(0, "否"),
        yes(1, "是");

        private int code;
        private String message;

        private LockStatus(int code, String message) {
            this.code = code;
            this.message = message;
        }

        public int getCode() {
            return code;
        }

        public String getMessage() {
            return message;
        }
    }

    /**
     * 车辆补电插口状态
     */
    public enum PluginStatus {
        unknown(0, "未知"),
        idle(1, "空闲"),
        connected(2, "已插枪"),
        charging(3, "充电中");

        private int code;
        private String message;

        private PluginStatus(int code, String message) {
            this.code = code;
            this.message = message;
        }

        public int getCode() {
            return code;
        }

        public String getMessage() {
            return message;
        }
    }
}