package com.xyhy.xingshenmqttcluster.common.mqtt;

import com.alibaba.fastjson.JSONObject;

import com.xyhy.xingshenmqttcluster.common.Common;
import com.xyhy.xingshenmqttcluster.common.message.MessageHandle;
import org.eclipse.paho.client.mqttv3.IMqttDeliveryToken;
import org.eclipse.paho.client.mqttv3.MqttCallback;
import org.eclipse.paho.client.mqttv3.MqttMessage;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

@Component
public class MqttGetMessage extends Common implements MqttCallback {


    @Override
    public void connectionLost(Throwable throwable) {
        log.error("MQTT连接已经断开！");
    }

    @Override
    public void messageArrived(String s, MqttMessage mqttMessage) throws Exception {
        JSONObject msg = JSONObject.parseObject(new String(mqttMessage.getPayload()));
        String msgType = msg.getString("msgType");
        int i = Integer.parseInt(msgType);
        log.info(new String(mqttMessage.getPayload()));
        switch (i) {
            case 1:
                MessageHandle.vehicleOnline(s, msg);
                break;
            case 2:
                MessageHandle.vehicleOffline(s, msg);
                break;
            case 3:
                MessageHandle.fuelState(s, msg);
                break;
            case 4:
                MessageHandle.vehicleState(s, msg);
                break;
            case 6:
                MessageHandle.vehicleStart(s, msg);
                break;
            case 8:
                MessageHandle.fault(s, msg);
                break;
            case 19:
                MessageHandle.arriveStationRequest(s, msg);
                break;
            case 102:
                MessageHandle.arrivePoint(s, msg);
                break;
            case 103:
                MessageHandle.leavePoint(s, msg);
                break;
            case 101:
                MessageHandle.gotoPoint(s, msg);
                break;
            case 800:
                MessageHandle.taskBegin(s, msg);
                break;
            case 801:
                MessageHandle.taskOver(s, msg);
                break;
            case 501:
                MessageHandle.startCarFailMsg(s, msg);
                break;
        }
    }

    @Override
    public void deliveryComplete(IMqttDeliveryToken iMqttDeliveryToken) {

    }
}
